import { DeviceEventEmitter } from 'react-native';
import { EventKeys } from '../enums';
class ReduxStorageEventListenerImpl {
    static _instance;
    static instance() {
        if (!ReduxStorageEventListenerImpl._instance) {
            ReduxStorageEventListenerImpl._instance =
                new ReduxStorageEventListenerImpl();
        }
        return ReduxStorageEventListenerImpl._instance;
    }
    _events = [];
    constructor() { }
    registerEvent(events) {
        if (typeof events !== 'object') {
            return;
        }
        Object.keys(events).forEach((e) => {
            const subscriptions = DeviceEventEmitter.addListener(EventKeys[e], events[e]);
            this._events.push(subscriptions);
        });
    }
    destroyAll() {
        this._events.forEach((event) => {
            event.remove();
        });
    }
}
export const ReduxStorageEventListener = ReduxStorageEventListenerImpl.instance();
